| OGRE 1.11.1 Object-Oriented Graphics Rendering Engine

Public Types | Public Member Functions | List of all members
Ogre::FileHandleDataStream Class Reference
Core » Resources

Common subclass of DataStream for handling data from C-style file handles. More...

`#include <OgreDataStream.h>`

Inheritance diagram for Ogre::FileHandleDataStream:
[legend]

## Public Types
enum | AccessMode { READ = 1, WRITE = 2 }

## Public Member Functions
| FileHandleDataStream (FILE *handle, uint16 accessMode=READ)
| Create stream from a C file handle. More...
| FileHandleDataStream (const String &name, FILE *handle, uint16 accessMode=READ)
| Create named stream from a C file handle. More...
| ~FileHandleDataStream ()
void | close (void)
| Close the stream; this makes further operations invalid. More...
bool | eof (void) const
| Returns true if the stream has reached the end. More...
uint16 | getAccessMode () const
| Gets the access mode of the stream. More...
virtual String | getAsString (void)
| Returns a String containing the entire stream. More...
virtual String | getLine (bool trimAfter=true)
| Returns a String containing the next line of data, optionally trimmed for whitespace. More...
const String & | getName (void)
| Returns the name of the stream, if it has one. More...
virtual bool | isReadable () const
| Reports whether this stream is readable. More...
virtual bool | isWriteable () const
| Reports whether this stream is writeable. More...
template<typename T >
DataStream & | operator>> (T &val)
size_t | read (void *buf, size_t count)
| Read the requisite number of bytes from the stream, stopping at the end of the file. More...
virtual size_t | readLine (char *buf, size_t maxCount, const String &delim="\)
| Get a single line from the stream. More...
void | seek (size_t pos)
| Repositions the read point to a specified byte. More...
size_t | size (void) const
| Returns the total size of the data to be read from the stream, or 0 if this is indeterminate for this stream. More...
void | skip (long count)
| Skip a defined number of bytes. More...
virtual size_t | skipLine (const String &delim="\)
| Skip a single line from the stream. More...
size_t | tell (void) const
| Returns the current byte offset from beginning. More...
size_t | write (const void *buf, size_t count)
| Write the requisite number of bytes from the stream (only applicable to streams that are not read-only) More...

## Detailed Description

Common subclass of DataStream for handling data from C-style file handles.

Remarks
  Use of this class is generally discouraged; if you want to wrap file access in a DataStream, you should definitely be using the C++ friendly FileStreamDataStream. However, since there are quite a few applications and libraries still wedded to the old FILE handle access, this stream wrapper provides some backwards compatibility.

## Member Enumeration Documentation

## ◆ AccessMode

enum Ogre::DataStream::AccessMode
| inherited

Enumerator
READ |
WRITE |

## Constructor & Destructor Documentation

## ◆ FileHandleDataStream() [1/2]

Ogre::FileHandleDataStream::FileHandleDataStream | ( | FILE * | handle,
|  | uint16 | accessMode = `READ`
| ) |  |

Create stream from a C file handle.

## ◆ FileHandleDataStream() [2/2]

Ogre::FileHandleDataStream::FileHandleDataStream | ( | const String & | name,
|  | FILE * | handle,
|  | uint16 | accessMode = `READ`
| ) |  |

Create named stream from a C file handle.

## ◆ ~FileHandleDataStream()

Ogre::FileHandleDataStream::~FileHandleDataStream | ( |  | ) |

## Member Function Documentation

## ◆ read()

size_t Ogre::FileHandleDataStream::read | ( | void * | buf,
|  | size_t | count
| ) |  |
| virtual

Read the requisite number of bytes from the stream, stopping at the end of the file.

Parameters

  buf | Reference to a buffer pointer
  count | Number of bytes to read

Returns
  The number of bytes read

Implements Ogre::DataStream.

## ◆ write()

size_t Ogre::FileHandleDataStream::write | ( | const void * | buf,
|  | size_t | count
| ) |  |
| virtual

Write the requisite number of bytes from the stream (only applicable to streams that are not read-only)

Parameters

  buf | Pointer to a buffer containing the bytes to write
  count | Number of bytes to write

Returns
  The number of bytes written

Reimplemented from Ogre::DataStream.

## ◆ skip()

void Ogre::FileHandleDataStream::skip | ( | long | count | ) |
| virtual

Skip a defined number of bytes.

This can also be a negative value, in which case the file pointer rewinds a defined number of bytes.

Implements Ogre::DataStream.

## ◆ seek()

void Ogre::FileHandleDataStream::seek | ( | size_t | pos | ) |
| virtual

Repositions the read point to a specified byte.

Implements Ogre::DataStream.

## ◆ tell()

size_t Ogre::FileHandleDataStream::tell | ( | void |  | ) | const
| virtual

Returns the current byte offset from beginning.

Implements Ogre::DataStream.

## ◆ eof()

bool Ogre::FileHandleDataStream::eof | ( | void |  | ) | const
| virtual

Returns true if the stream has reached the end.

Implements Ogre::DataStream.

## ◆ close()

void Ogre::FileHandleDataStream::close | ( | void |  | ) |
| virtual

Close the stream; this makes further operations invalid.

Implements Ogre::DataStream.

## ◆ getName()

const String& Ogre::DataStream::getName | ( | void |  | ) |
| inline inherited

Returns the name of the stream, if it has one.

## ◆ getAccessMode()

uint16 Ogre::DataStream::getAccessMode | ( |  | ) | const
| inline inherited

Gets the access mode of the stream.

## ◆ isReadable()

virtual bool Ogre::DataStream::isReadable | ( |  | ) | const
| inline virtual inherited

Reports whether this stream is readable.

## ◆ isWriteable()

virtual bool Ogre::DataStream::isWriteable | ( |  | ) | const
| inline virtual inherited

Reports whether this stream is writeable.

## ◆ operator>>()

template<typename T >

DataStream& Ogre::DataStream::operator>> | ( | T & | val | ) |
| inherited

## ◆ readLine()

virtual size_t Ogre::DataStream::readLine | ( | char * | buf,
|  | size_t | maxCount
| ) |  |
| virtual inherited

Get a single line from the stream.

Remarks
  The delimiter character is not included in the data returned, and it is skipped over so the next read will occur after it. The buffer contents will include a terminating character.

Note
  If you used this function, you must open the stream in binary mode, otherwise, it'll produce unexpected results.

Parameters

  buf | Reference to a buffer pointer
  maxCount | The maximum length of data to be read, excluding the terminating character
  delim | The delimiter to stop at

Returns
  The number of bytes read, excluding the terminating character

Reimplemented in Ogre::FileStreamDataStream, and Ogre::MemoryDataStream.

## ◆ getLine()

virtual String Ogre::DataStream::getLine | ( | bool | trimAfter = `true` | ) |
| virtual inherited

Returns a String containing the next line of data, optionally trimmed for whitespace.

Remarks
  This is a convenience method for text streams only, allowing you to retrieve a String object containing the next line of data. The data is read up to the next newline character and the result trimmed if required.

Note
  If you used this function, you must open the stream in binary mode, otherwise, it'll produce unexpected results.

Parameters

  trimAfter | If true, the line is trimmed for whitespace (as in String.trim(true,true))

## ◆ getAsString()

virtual String Ogre::DataStream::getAsString | ( | void |  | ) |
| virtual inherited

Returns a String containing the entire stream.

Remarks
  This is a convenience method for text streams only, allowing you to retrieve a String object containing all the data in the stream.

## ◆ skipLine()

virtual size_t Ogre::DataStream::skipLine | ( |  | ) |
| virtual inherited

Skip a single line from the stream.

Note
  If you used this function, you must open the stream in binary mode, otherwise, it'll produce unexpected results.

Parameters

  delim | The delimiter(s) to stop at

Returns
  The number of bytes skipped

Reimplemented in Ogre::MemoryDataStream.

## ◆ size()

size_t Ogre::DataStream::size | ( | void |  | ) | const
| inline inherited

Returns the total size of the data to be read from the stream, or 0 if this is indeterminate for this stream.

The documentation for this class was generated from the following file:

- OgreDataStream.h